#define __STR(x) #x
#define STR(x) __STR(x)

extern void rtl_fpu_save (RT_TASK *task);
extern void rtl_fpu_restore (RT_TASK *task);
extern void rtl_task_init_fpu (RT_TASK *t, RT_TASK *fpu_owner);

#define rtl_switch_to(tsk) \
	__asm__ __volatile__( \
	"pushl %%eax\n\t" \
	"pushl %%ebp\n\t" \
	"pushl %%edi\n\t" \
	"pushl %%esi\n\t" \
	"pushl %%edx\n\t" \
	"pushl %%ecx\n\t" \
	"pushl %%ebx\n\t" \
	"movl "SYMBOL_NAME_STR(rtl_current)", %%edx\n\t" \
	"pushl $1f\n\t" \
	"movl %%esp, (%%edx)\n\t" \
	"movl (%%ecx), %%esp\n\t" \
	"movl %%ecx, "SYMBOL_NAME_STR(rtl_current)"\n\t" \
	"ret\n\t" \
"1:	popl %%ebx\n\t" \
	"popl %%ecx\n\t" \
	"popl %%edx\n\t" \
	"popl %%esi\n\t" \
	"popl %%edi\n\t" \
	"popl %%ebp\n\t" \
	"popl %%eax\n\t" \
	: /* no output */ \
	: "c" (tsk) \
	:"cx");

#define x86_init_stack(task,data,rt_startup)\
	{\
	*--(task->stack) = data;\
	*--(task->stack) = (int) fn;\
	*--(task->stack) = 0;	/* dummy return addr*/\
	*--(task->stack) = (int) rt_startup;\
	}

